const MY_EXTENSION_UUID = "infonotary-mozilla-setup@infonotary.com";
const PREF_BRANCH = "extensions.infonotary-mozilla-setup."
var INSTALL_PREF_NAME = PREF_BRANCH + "lastVersion";

var Cc = Components.classes;
var Ci = Components.interfaces;

var pref = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);

//var gConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

function furst_run()
{
	if( is_silent_module_install_posible() )
	{
		setup_pkcs11_module();
		return;
	}
	var installer = false;
	try{
		installer = pref.getBoolPref( PREF_BRANCH + "installer" );
	} catch(e) {
		//gConsoleService.logStringMessage(e);
	}
	if( !installer )
		if( setup_is_needed( null ) )
			window.openDialog('chrome://infonotary-mozilla-setup/content/settings.xul', '', 'chrome,centerscreen');
}

function checkVersion( addon )
{
	var finished = "";

	try {
		finished = pref.getCharPref( INSTALL_PREF_NAME );
	} catch(e) {
		//gConsoleService.logStringMessage(e);
	}
	if (finished != addon.version) {
		setup_cert_chain( false );
		furst_run();
		pref.setCharPref( INSTALL_PREF_NAME, addon.version );
	}
}

function initializeOverlay()
{
	if( Ci.nsIExtensionManager ) //Gecko before version 2.0
	{
		var extManager = Cc["@mozilla.org/extensions/manager;1"].getService(Ci.nsIExtensionManager);
		var addon = extManager.getItemForID( MY_EXTENSION_UUID ); // em:id in install.rdf
		checkVersion(addon);
		UninstallObserver.register();
	}
	else //Gecko 2.0 and up
	{
		Components.utils.import("resource://gre/modules/AddonManager.jsm");
		AddonManager.getAddonByID(MY_EXTENSION_UUID, function(addon) {
			checkVersion(addon);
		});
		UninstallObserver.registerG2();
	}
	window.removeEventListener("load", initializeOverlay, false);
}

var UninstallObserver = {
	_pref_val : "",
	observe : function(subject, topic, data) {
		if (topic == "em-action-requested") {
			subject.QueryInterface(Ci.nsIUpdateItem);

			if (subject.id == MY_EXTENSION_UUID) {
				if (data == "item-uninstalled") {
					this.uninstallEvent();
				} else if (data == "item-cancel-action") {
					this.cancelEvent();
				}
			}
		} else if (topic == "quit-application-granted") {
			this.unregister();
		}
	},
	register : function() {
		var observerService = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);

		observerService.addObserver(this, "em-action-requested", false);
		observerService.addObserver(this, "quit-application-granted", false);
	},
	unregister : function() {
		var observerService = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);

		observerService.removeObserver(this,"em-action-requested");
		observerService.removeObserver(this,"quit-application-granted");
	},
	uninstallEvent: function()
	{
		try {
			this._pref_val = pref.getCharPref( INSTALL_PREF_NAME );
			pref.clearUserPref( INSTALL_PREF_NAME );
		} catch(e) {
			//gConsoleService.logStringMessage(e);
		}
	},
	cancelEvent: function()
	{
		pref.setCharPref( INSTALL_PREF_NAME, this._pref_val );
	},
	//Gecko 2.0 support:
	onUninstalling: function(addon) {
		if (addon.id == MY_EXTENSION_UUID)
			this.uninstallEvent();
	},
	onOperationCancelled: function(addon) {
		if (addon.id == MY_EXTENSION_UUID)
			this.cancelEvent();
	},
	registerG2: function()
	{
		try {
			AddonManager.addAddonListener(this);
		} catch (e) {}
	}
}

window.addEventListener("load", initializeOverlay, false);
