function message_box(message, title, icon) {
	//Possible values for icon: alert-icon, error-icon, message-icon, question-icon
	return openDialog("chrome://infonotary-mozilla-setup/content/messagebox.xul",
					  "IMS-msgBox", "chrome,centerscreen,modal,dialog",
					  message, title, icon);
}

function alert_error( text )
{
	var err = null;
	var strbundle = document.getElementById("inmozsetup-strings");
	if( text == "error:internalError" )
		err = strbundle.getString("signTestInternalError");
	else if( text == "error:noMatchingCert" )
		err = strbundle.getString("signTestNoMatchingCert");
	if( err )
		message_box(err, strbundle.getString("signTestErrorTitle"), "error-icon");
}

function sign_test( txt )
{
	var strbundle = document.getElementById("inmozsetup-strings");
	if( !cert_chain_is_installed() )
	{
		var msg = strbundle.getString("signTestNoChain");
		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
		if( prompts.confirm(window, title, msg) )
			setup_cert_chain( true );
		else
			return true; // User canceled test
	}
	var res = window.crypto.signText( txt, "ask" );
	alert_error( res );
	if( res == "error:userCancel" )
		return true;
	if( res.indexOf( "error:" ) == -1 )
	{
		message_box(strbundle.getString("signTestOK"), strbundle.getString("signTestOKTitle"), "message-icon");
		return true;
	}
	return false;
}
